/**
*	lcd.c
*	kbchCoiQO~SsΉC^[tF[X͂Srbgf[^j
*	PORT 1		b2- D4
*			b3- D5
*			b4- D6
*			b5- D7
*			b6- E
*			b7- RS
*	Copyright (c)Junnichi Tomaru 2002-2006
*/
#include	"lcd.h"
#include	"r8c29.h"
#include	"userdef.h"
extern void	waitms( word wait );

#define LCD_DATA	PORT1

#define ASSERT_RS( )	P1_7=1
#define ASSERT_E( )	P1_6=1

#define NEGATE_RS( )	P1_7=0
#define NEGATE_E( )	P1_6=0

#define	nop( )	{asm("nop");asm("nop");asm("nop");asm("nop");}


/**
*	Pus҂
*	1us = (1/20M)*20cycle
*	 in:Ȃ
*	out:Ȃ
*/
void	wait1us( void )
{	/* 14cycle(JSR,RTS) */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 = 20cycle */
}


/**
*	10us҂
*	 in:Ȃ
*	out:Ȃ
*/
void	wait10us( void )
{
	/* 14cycle(JSR,RTS) */
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 = 20cycle */
}


/**
*	50us҂
*	 in:Ȃ
*	out:Ȃ
*/
void	wait50us( void )
{
	/* 14cycle(JSR,RTS) */
	wait10us( );
	wait10us( );
	wait10us( );
	wait10us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	wait1us( );
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 */
	asm( "nop" );	/* +1 = 20cycle */
}


/**
*	f[^Zbg
*	 in	f[^
*	out	Ȃ
*/
void	write_data( unsigned char data )
{
	byte	dat;

	dat = LCD_DATA & 0xc3;
	dat |= ( data << 2 );
	LCD_DATA = dat;
}


/**
*	kbcɃf[^
*	 in	f[^
*	out	Ȃ
*/
void	lcdwrite( unsigned char data )
{
	nbl_t	d;

	d.data = data;
	write_data( d.nbl.hi );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
	write_data( d.nbl.lo );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
}


/**
*	CXgNV
*	 in	f[^
*	out	Ȃ
*/
void	lcdwriteir( unsigned char data )
{
	NEGATE_RS( );
	lcdwrite( data );
}


/**
*	f[^WX^
*	 in	f[^
*	out	Ȃ
*/
void	lcdwritedr( unsigned char data )
{
	ASSERT_RS( );
	lcdwrite( data );
}


/**
*	CXgNViSrbgj
*	 in	f[^
*	out	Ȃ
*/
void	lcdwriteir4( unsigned char data )
{
	NEGATE_RS( );
	write_data( data );
	nop( );
	ASSERT_E( );
	nop( );
	NEGATE_E( );
}


/**
*	kbc
*	 in	Ȃ
*	out	Ȃ
*/
void	lcdinit( void )
{
	/* V[PX */
	waitms( 20 );		/* Wait 20 ms */
	lcdwriteir4( 0x03 );
	waitms( 4 );
	lcdwriteir4( 0x03 );
	waitms( 1 );
	lcdwriteir4( 0x03 );
	waitms( 1 );
	lcdwriteir4( 0x02 );	/* Data length 4bits */
	waitms( 1 );
	lcdwriteir( 0x28 );	/* Set function */
	wait50us( );
	lcdwriteir( 0x08 );	/* Display off, cursor off, blink off */
	wait50us( );
	lcdwriteir( 0x01 );	/* Clear display */
	waitms( 2 );
	lcdwriteir( 0x06 );	/* Entry mode : cursor increment */
	wait50us( );
	lcdwriteir( 0x0C );	/* Display on, cursor off, blink off */
}


/**
*	J[\ʒuw
*	 in	x:ʒu
*		y:sʒu
*	out	Ȃ
*/
void	lcdlocate( char x, char y )
{
	byte	addr;

	addr = x;
	switch( y ){
		 case 0:	addr += 0x00;
		_case 1:	addr += 0x40;
		_case 2:	addr += 0x14;
		_case 3:	addr += 0x54;
		_default:	return;
	}
	lcdwriteir( addr | 0x80 );	/* Set DD RAM address */
	wait50us( );
}


/**
*	ʃNA
*	 in	Ȃ
*	out	Ȃ
*/
void	lcdcls( void )
{
	lcdwriteir( 0x01 );
	waitms( 4 );	/* q̂Ŕ{҂ */
}


/**
*	J[\\E\
*	 in	0:\ ̑:\
*	out	Ȃ
*/
void	lcddispcursor( char sw )
{
	lcdwriteir( 0xc | ( sw ? 0x02 : 0 ));
	wait50us( );
}


/**
*	ꕶ\
*	 in	f[^
*	out	Ȃ
*/
void	lcdputch( char c )
{
	lcdwritedr( c );
	wait50us( );
}


/**
*	wʒuɈꕶ\iLN^R[hwj
*	 in	   x:ʒu
*		   y:sʒu
*		code:f[^
*	out	Ȃ
*/
void	lcdputcode( char x, char y, char code )
{
	lcdlocate( x, y );
	lcdwritedr( code );
	wait50us( );
}


/**
*	\
*	 in	f[^
*	out	Ȃ
*/
void	lcdputstr( char *str )
{
	char	c;

	while( 1 ){
		c = *str;
		if( c == '\0' ){
			break;
		}
		lcdputch( c );
		str++;
	}
}


/**
*	ʒuw肵ĕ\
*	 in	  x:ʒu
*		  y:sʒu
*		str:f[^
*	out	Ȃ
*/
void	lcdprint( char x, char y, char *str )
{
	lcdlocate( x, y );
	lcdputstr( str );
}


/**
*	wʒuw萔̕
*	 in	  x:ʒu
*		  y:sʒu
*		cnt:
*	out	Ȃ
*/
void	lcdspace( char x, char y, char cnt )
{
	char	i;

	lcdlocate( x, y );
	for( i = 0; i < cnt; i++ ){
		lcdputch( ' ' );
	}
}


/**
*	sNA
*	 in	NAs
*	out	Ȃ
*/
void	lcdlcls( char line )
{
	lcdspace( 0, line, 20 );
}


/* end of lcd.c */
