/**
*	R8C/28 & R8C/29 Group SFR
*	redefined by J.T
*/
#include	"sfr_r829.h"

/* Processor mode register0 */
#define	PM0	pm0
#define	PM03	pm03	/* Software reset bit */

/* Processor mode register1 */
#define	PM1	pm1
#define	PM12	pm12	/* WDT interrupt/reset switch bit */

/* System clock control register0 */
#define	CM0	cm0
#define	CM01	cm01	/* Clock output function select bit */
#define	CM02	cm02	/* WAIT peripheral function clock stop bit */
#define	CM03	cm03	/* Xcin-Xcout drive capacity select bit */
#define	CM04	cm04	/* Xcin clock (Xcin-Xcout) start bit */
#define	CM05	cm05	/* Xin clock (Xin-Xout) stop bit */
#define	CM06	cm06	/* System clock division select bit0 */

/* System clock control register1 */
#define	CM1	cm1
#define	CM10	cm10	/* All clock stop control bit */
#define	CM11	cm11	/* XIN-XOUT internal resistor select bit */
#define	CM12	cm12	/* XCIN-XCOUT internal resistor select bit */
#define	CM13	cm13	/* Port Xin-Xout switch bit */
#define	CM14	cm14	/* Low-speed on-chip oscillator stop bit */
#define	CM15	cm15	/* Xin-Xout drive capability select bit */
#define	CM16	cm16	/* System clock division select bit1 */
#define	CM17	cm17	/*  */

/* Protect register */
#define	PRCR	prcr
#define	PRC0	prc0	/* Protect bit0 */
#define	PRC1	prc1	/* Protect bit1 */
#define	PRC3	prc3	/* Protect bit3 */

/* Oscillation stop detection register */
#define	OCD	ocd

#define	OCD0	ocd0	/* Oscillation stop detection enable bit */
#define	OCD1	ocd1	/* Oscillation stop detection interrupt enable bit */
#define	OCD2	ocd2	/* System clock select bit */
#define	OCD3	ocd3	/* Clock monitor bit */

/* Watchdog timer reset register */
#define	WDTR	wdtr

/* Watchdog timer start register */
#define	WDTS	wdts

/* Watchdog timer control register */
#define	WDC	wdc

#define	WDC7	wdc7	/* Prescaler select bit */

/* Address match interrupt enable register */
#define	AIER	aier

#define	AIER0	aier0	/* Address match interrupt 0 enable bit */
#define	AIER1	aier1	/* Address match interrupt 1 enable bit */

/* Count source protection mode register */
#define	CSPR	cspr

#define	CSPRO	cspro	/* Count source protection mode select bit */

/* High-speed on-chip oscillator control register 0 */
#define	FRA0	fra0	

#define	FRA00	fra00	/* High-speed on-chip oscillator enable bit */
#define	FRA01	fra01	/* High-speed on-chip oscillator select bit */

/* High-speed on-chip oscillator control register 1 */
#define	FRA1	fra1

/* High-speed on-chip oscillator control register 2 */
#define	FRA2	fra2
#define	FRA20	fra20	/* High-speed on-chip oscillator frequency switching bit */
#define	FRA21	fra21	/* High-speed on-chip oscillator frequency switching bit */
#define	FRA22	fra22	/* High-speed on-chip oscillator frequency switching bit */

/* Clock prescaler reset flag */
#define	CPSRF	cpsrf
#define	CPSR	cpsr	/* Clock prescaler reset flag */

/* Voltage detection register 1 */
#define	VCA1	vca1
#define	VCA13	vca13	/* Voltage detection 2 signal monitor flag */

/* Voltage detection register 2 */
#define	VCA2	vca2
#define	VCA20	vca20	/* Internal power supply low power consumption enable bit */
#define	VCA25	vca25	/* Voltage detection 0 enable bit */
#define	VCA26	vca26	/* Voltage detection 1 enable bit */
#define	VCA27	vca27	/* Voltage detection 2 enable bit */

/* Voltage monitor 1 circuit control register */
#define	VW1C	vw1c

#define	VW1C0	vw1c0	/* Voltage monitor 1 interrupt / reset enable bit */
#define	VW1C1	vw1c1	/* Voltage Monitor 1 digital filter disable mode select bit */
#define	VW1C2	vw1c2	/* Voltage change detection flag */
#define	VW1C3	vw1c3	/* Voltage detection 1 signal monitor flag */
#define	VW1F0	vw1f0	/* Sampling clock select bit */
#define	VW1F1	vw1f1	/* Sampling clock select bit */
#define	VW1C6	vw1c6	/* Voltage monitor 1 circuit mode select bit */
#define	VW1C7	vw1c7	/* Voltage monitor 1 interrupt / reset generation condition select bit */

/* Voltage monitor 2 circuit control register */
#define	VW2C	vw2c

#define	VW2C0	vw2c0	/* Voltage monitor 2 interrupt / reset enable bit */
#define	VW2C1	vw2c1	/* Voltage monitor 2 digital filter disabled mode select bit */
#define	VW2C2	vw2c2	/* Voltage change detection flag */
#define	VW2C3	vw2c3	/* WDT Detection Flag */
#define	VW2F0	vw2f0	/* Sampling clock select bit */
#define	VW2F1	vw2f1	/* Sampling clock select bit */
#define	VW2C6	vw2c6	/* Voltage monitor 2 circuit mode select bit */
#define	VW2C7	vw2c7	/* Voltage monitor 2 interrupt / reset generation condition select bit */

/* Voltage monitor 0 circuit control register */
#define	VW0C	vw0c

#define	VW0C0	vw0c0	/* Voltage monitor 0 reset enable bit */
#define	VW0C1	vw0c1	/* Voltage monitor 0 digital filter disabled mode select bit */
#define	VW0C2	vw0c2	/*  */
#define	VW0F0	vw0f0	/* Sampling clock select bit */
#define	VW0F1	vw0f1	/* Sampling clock select bit */
#define	VW0C6	vw0c6	/* Voltage monitor 0 circuit mode select bit */
#define	VW0C7	vw0c7	/* Voltage monitor 0 reset generation condition select bit */

/* UART0 bit rate register */
#define	U0BRG	u0brg

/* UART1 bit rate register */
#define	U1BRG	u1brg

/* SS control register H */
#define	SSCRH	sscrh

#define	CKS0_SSCRH	cks0_sscrh	/* Transfer clock rate select bit */
#define	CKS1_SSCRH	cks1_sscrh	/* Transfer clock rate select bit */
#define	CKS2_SSCRH	cks2_sscrh	/* Transfer clock rate select bit */
#define	CSS_SSCRH	mss_sscrh	/* Master/Slave device select bit */
#define	RSSTP_SSCRH	rsstp_sscrh	/* Receive single stop bit */

/* SS control register L */
#define	SSCRL	sscrl

#define	SRES_SSCRL	sres_sscrl	/* Clock synchronous serial I/O with chip select control part reset bit */
#define	SOLP_SSCRL	solp_sscrl	/* SOL write protect bit */
#define	SOL_SSCRL	sol_sscrl	/* Serial data output value setting bit */

/* SS mode register */
#define	SSMR	ssmr

#define	BC0_SSMR	bc0_ssmr	/* Bit counter 2 to 0 */
#define	BC1_SSMR	bc1_ssmr	/* Bit counter 2 to 0 */
#define	BC2_SSMR	bc2_ssmr	/* Bit counter 2 to 0 */
#define	CPHS_SSMR	cphs_ssmr	/* SSCK clock phase select bit */
#define	CPOS_SSMR	cpos_ssmr	/* SSCK clock polarity select bit */
#define	MLS_SSMR	mls_ssmr	/* MSB first/ LSB first select bit */

/* SS enable register */
#define	SSER	sser

#define	CEIE_SSER	ceie_sser	/* Conflict error interrupt enable bit */
#define	RE_SSER		re_sser		/* Receive enable bit */
#define	TE_SSER		te_sser		/* Transmit enable bit */
#define	RIE_SSER	rie_sser	/* Receive interrupt enable bit */
#define	TEIE_SSER	teie_sser	/* Transmit end interrupt enable bit */
#define	TIE_SSER	tie_sser	/* Transmit interrupt enable bit */

/* SS status register */
#define	SSSR	sssr

#define	CE_SSSR		ce_sssr		/* Conflict error flag */
#define	ORER_SSSR	orer_sssr	/* Overrun error flag */
#define	RDRF_SSSR	rdrf_sssr	/* Receive data register full */
#define	TEND_SSSR	tend_sssr	/* Transmit end */
#define	TDRE_SSSR	tdre_sssr	/* Transmit data empty */

/* SS mode register 2 */
#define	SSMR2	ssmr2

#define	SSUMS_SSMR2	ssums_ssmr2	/* Clock synchronous serial I/O with chip select mode select bit */
#define	CSOS_SSMR2	csos_ssmr2	/* SCS pin open drain output select bit */
#define	SOOS_SSMR2	soos_ssmr2	/* SSO pin open drain output select bit */
#define	SCKOS_SSMR2	sckos_ssmr2	/* SSCK pin open drain output select bit */
#define	CSS0_SSMR2	css0_ssmr2	/* SCS pin selsct bit */
#define	CSS1_SSMR2	css1_ssmr2	/* SCS pin select bit */
#define	SCKS_SSMR2	scks_ssmr2	/* SSCK pin select bit */
#define	BIDE_SSMR2	bide_ssmr2	/* Bidirectional mode enable bit */

/* SS transmit data register */
#define	SSTDR	sstdr

/* SS receive data register */
#define	SSRDR	ssrdr

/* IIC bus control register 1 */
#define	ICCR1	iccr1

#define	CKS0_ICCR1	cks0_iccr1	/* Transmit clock select bit 3 to 0 */
#define	CKS1_ICCR	cks1_iccr1	/* Transmit clock select bit 3 to 0 */
#define	CKS2_ICCR1	cks2_iccr1	/* Transmit clock select bit 3 to 0 */
#define	CKS3_ICCR1	cks3_iccr1	/* Transmit clock select bit 3 to 0 */
#define	TRS_ICCR1	trs_iccr1	/* Transfer/receive select bit */
#define	MST_ICCR1	mst_iccr1	/* Master/slave select bit */
#define	RCVD_ICCR1	rcvd_iccr1	/* Receive disable bit */
#define	ICE_ICCR1	ice_iccr1	/* IIC bus interface enable bit */

/* IIC bus control register 2 */
#define	ICCR2	iccr2

#define	IICRST_ICCR2	iicrst_iccr2	/* IIC control part reset bit */
#define	SCLO_ICCR2	sclo_iccr2	/* SCL monitor flag */
#define	SDAOP_ICCR2	sdaop_iccr2	/* SDAO write protect bit */
#define	SDAO_ICCR2	sdao_iccr2	/* SDA output value control bit */
#define	SCP_ICCR2	scp_iccr2	/* Start/Stop condition generation disable bit */
#define	BBSY_ICCR2	bbsy_iccr2	/* Bus busy bit */

/* IIC bus mode register */
#define	ICMR	icmr

#define	BC0_ICMR	bc0_icmr	/* Bit counter 2 to 0 */
#define	BC1_ICMR	bc1_icmr	/* Bit Counter 2 to 0 */
#define	BC2_ICMR	bc2_icmr	/* Bit Counter 2 to 0 */
#define	BCWP_ICMR	bcwp_icmr	/* BC write protect bit */
#define	WAIT_ICMR	wait_icmr	/* Wait insertion bit */
#define	MLS_ICMR	mls_icmr	/* MSB-First/LSB-First select */

/* IIC bus interrupt enable register */
#define	ICIER	icier

#define	ACKBT_ICIER	ackbt_icier	/* Transmit acknow ledge select bit */
#define	ACKBR_ICIER	ackbr_icier	/* Receive acknow ledge bit */
#define	ACKE_ICIER	acke_icier	/* Acknowledge bit judgement select bit */
#define	STIE_ICIER	stie_icier	/* Stop condition detection interrupt enable bit */
#define	NAKIE_ICIER	nakie_icier	/* NACK receive interrupt enable bit */
#define	RIE_ICIER	rie_icier	/* Receive interrupt enable bit */
#define	TEIE_ICIER	teie_icier	/* Transmit end interrupt enable bit */
#define	TIE_ICIER	tie_icier	/* Transmit interrupt enable bit */

/* IIC bus status register */
#define	ICSR	icsr

#define	ADZ_ICSR	adz_icsr	/* General call address recognition flag */
#define	AAS_ICSR	aas_icsr	/* Slave address recognition flag */
#define	AL_ICSR		al_icsr		/* Arbitration lost flag / Overrun error flag */
#define	STOP_ICSR	stop_icsr	/* Stop condition detection flag */
#define	NACKF_ICSR	nackf_icsr	/* No acknow ledge detection flag */
#define	RDRF_ICSR	rdrf_icsr	/* Receive data register full */
#define	TEND_ICSR	tend_icsr	/* Transmit end */
#define	TDRE_ICSR	tdre_icsr	/* Transmit data empty */

/* Slave address register */
#define	SAR	sar

#define	FS_SAR		fs_sar		/* Format select bit */
#define	SVA0_SAR	sva0_sar	/* Slave address 6 to 0 */
#define	SVA1_SAR	sva1_sar	/* Slave address 6 to 0 */
#define	SVA2_SAR	sva2_sar	/* Slave address 6 to 0 */
#define	SVA3_SAR	sva3_sar	/* Slave address 6 to 0 */
#define	SVA4_SAR	sva4_sar	/* Slave address 6 to 0 */
#define	SVA5_SAR	sva5_sar	/* Slave address 6 to 0 */
#define	SVA6_SAR	sva6_sar	/* Slave address 6 to 0 */

/* IIC bus transmit data register */
#define	ICDRT	icdrt

/* IIC bus receive data register */
#define	ICDRR	icdrr

/* A-D control register2 */
#define	ADCON2	adcon2

#define	SMP	smp	/* A-D conversion method select bit */

/* A-D control register0 */
#define	ADCON0	adcon0

#define	CH0	ch0	/* Analog input pin select bit */
#define	CH1	ch1	/* Analog input pin select bit */
#define	CH2	ch2	/* Analog input pin select bit */
#define	MD	md	/* A-D operation mode select bit */
#define	ADGSEL0	adgsel0	/* A-D input group select bit */
#define	ADST	adst	/* A-D conversion start flag */
#define	CKS0_ADCON0	cks0_adcon0	/* Frequency select bit0 */

/* A-D control register1 */
#define	ADCON1	adcon1

#define	BITS	bits			/* 8/10-bit mode select bit */
#define	CKS1_ADCON1	cks1_adcon1	/* Frequency select bit1 */
#define	VCUT	vcut			/* Vref connect bit */

/* Port P1 register */
#define	PORT1	p1

#define	P1_0	p1_0		/* Port P10 bit */
#define	P1_1	p1_1		/* Port P11 bit */
#define	P1_2	p1_2		/* Port P12 bit */
#define	P1_3	p1_3		/* Port P13 bit */
#define	P1_4	p1_4		/* Port P14 bit */
#define	P1_5	p1_5		/* Port P15 bit */
#define	P1_6	p1_6		/* Port P16 bit */
#define	P1_7	p1_7		/* Port P17 bit */

/* Port P1 direction register */
#define	PD1	pd1

#define	PD1_0	pd1_0		/* Port P10 direction bit */
#define	PD1_1	pd1_1		/* Port P11 direction bit */
#define	PD1_2	pd1_2		/* Port P12 direction bit */
#define	PD1_3	pd1_3		/* Port P13 direction bit */
#define	PD1_4	pd1_4		/* Port P14 direction bit */
#define	PD1_5	pd1_5		/* Port P15 direction bit */
#define	PD1_6	pd1_6		/* Port P16 direction bit */
#define	PD1_7	pd1_7		/* Port P17 direction bit */

/* Port P3 register */
#define	PORT3	p3

#define	P3_3	p3_3		/* Port P33 bit */
#define	P3_4	p3_4		/* Port P34 bit */
#define	P3_5	p3_5		/* Port P35 bit */
#define	P3_7	p3_7		/* Port P37 bit */

/* Port P3 direction register */
#define	PD3	pd3

#define	PD3_3	pd3_3		/* Port P33 direction bit */
#define	PD3_4	pd3_4		/* Port P34 direction bit */
#define	PD3_5	pd3_5		/* Port P35 direction bit */
#define	PD3_7	pd3_7		/* Port P37 direction bit */

/* Port P4 register */
#define	PORT4	p4

#define	P4_2	p4_2		/* Port P42 bit */
#define	P4_5	p4_5		/* Port P45 bit */
#define	P4_6	p4_6		/* Port P46 bit */
#define	P4_7	p4_7		/* Port P47 bit */

/* Port P4 direction register */
#define	PD4	pd4

#define	PD4_5	pd4_5		/* Port P45 direction bit */

/* Port select register 1 */
#define	PINSR1	pinsr1

#define	UART1SEL0	uart1sel0	/* Port TXD1/RXD1 switch bit */
#define	UART1SEL1	uart1sel1	/* Port TXD1/RXD1 switch bit */

/* Port select register 2 */
#define	PINSTR2	pinsr2

#define	TRBOSEL	trbosel		/* Port TRBO enable bit */

/* Port select register 3 */
#define	PINSR3	pinsr3

#define	TRCIOCSEL	trciocsel	/* Port TRCIOC enable bit */
#define	TRCIODSEL	trciodsel	/* Port TRCIOD enablet bit */

/* Port mode register */
#define	PMR	pmr

#define	SSISEL	ssisel		/* SSI pin select bit */
#define	U1PINSEL	u1pinsel	/* TXD1 pin select bit */
#define	TXD1SEL	txd1sel		/* Port/TXD1 pin select bit */
#define	TXD1EN	txd1en		/* TXD1/RXD1 pin select bit */
#define	IICSEL	iicsel		/* SSU/IIC bus switch bit */

/* External input enable register */
#define	INTEN	inten

#define	INT0EN	int0en		/* INT0 input enable bit */
#define	INT0PL	int0pl		/* INT0 input polarity select bit */
#define	INT1EN	int1en		/* INT1 input enable bit */
#define	INT1PL	int1pl		/* INT1 input polarity select bit */
#define	INT3EN	int3en		/* INT3 input enable bit */
#define	INT3PL	int3pl		/* INT3 input polarity select bit */

/* INT0 input filter select register */
#define	INTF	intf

#define	INT0F0	int0f0		/* INT0 input filter select bit */
#define	INT0F1	int0f1		/* INT0 input filter select bit */
#define	INT1F0	int1f0		/* INT1 input filter select bit */
#define	INT1F1	int1f1		/* INT1 input filter select bit */
#define	INT3F0	int3f0		/* INT3 input filter select bit */
#define	INT3F1	int3f1		/* INT3 input filter select bit */

/* Key input enable register */
#define	KIEN	kien

#define	KI0EN	ki0en		/* KI0 input enable bit */
#define	KI0PL	ki0pl		/* KI0 input polarity select bit */
#define	KI1EN	ki1en		/* KI1 input enable bit */
#define	KI1PL	ki1pl		/* KI1 input polarity select bit */
#define	KI2EN	ki2en		/* KI2 input enable bit */
#define	KI2PL	ki2pl		/* KI2 input polarity select bit */
#define	KI3EN	ki3en		/* KI3 input enable bit */
#define	KI3PL	ki3pl		/* KI3 input polarity select bit */

/* Pull-up control register0 */
#define	PUR0	pur0

#define	PU02	pu02		/* P10 to P13 pull-up */
#define	PU03	pu03		/* P14 to P17 pull-up */
#define	PU06	pu06		/* P31, P33 pull-up */
#define	PU07	pu07		/* P34 to P37 pull-up */

/* Pull-up control register1 */
#define	PUR1	pur1

#define	PU11	pu11		/* P45 pull-up */

/* Port P1 drivability control register */
#define	P1DRR	p1drr

#define	P1DRR0	p1drr0		/* P10 drive capacity */
#define	P1DRR1	p1drr1		/* P11 drive capacity */
#define	P1DRR2	p1drr2		/* P12 drive capacity */
#define	P1DRR3	p1drr3		/* P13 drive capacity */
#define	P1DRR4	p1drr4		/* P14 drive capacity */
#define	P1DRR5	p1drr5		/* P15 drive capacity */
#define	P1DRR6	p1drr6		/* P16 drive capacity */
#define	P1DRR7	p1drr7		/* P17 drive capacity */

/* Timer RA control register */
#define	TRACR	tracr

#define	TSTART_TRACR	tstart_tracr	/* Timer RA count start bit */
#define	TCSTF_TRACR	tcstf_tracr	/* Timer RA count status flag */
#define	TSTOP_TRACR	tstop_tracr	/* Timer RA count forcible stop bit */
#define	TEDGF_TRACR	tedgf_tracr	/* Active edge judgment flag */
#define	TUNDF_TRACR	tundf_tracr	/* Timer RA underflow flag */

/* Timer RA I/O control register */
#define	TRAIOC	traioc

#define	TEDGSEL_TRAIOC	tedgsel_traioc	/* TRAIO polarity switch bit */
#define	TOPCR_TRAIOC	topcr_traioc	/* TRAIO output control bit */
#define	TOENA_TRAIOC	toena_traioc	/* TRAO output enable bit */
#define	TIOSEL_TRAIOC	tiosel_traioc	/* INT1/TRAIO select bit */
#define	TIPF0_TRAIOC	tipf0_traioc	/* TRAIO input filter select bit */
#define	TIPF1_TRAIOC	tipf1_traioc	/* TRAIO input filter select bit */

/* Timer RA mode register */
#define	TRAMR	tramr

#define	TMOD0_TRAMR	tmod0_tramr	/* Timer RA operation mode select bit */
#define	TMOD1_TRAMR	tmod1_tramr	/* Timer RA operation mode select bit */
#define	TMOD2_TRAMR	tmod2_tramr	/* Timer RA operation mode select bit */
#define	TCK0_TRAMR	tck0_tramr	/* Timer RA count source select bit */
#define	TCK1_TRAMR	tck1_tramr	/* Timer RA count source select bit */
#define	TCK2_TRAMR	tck2_tramr	/* Timer RA count source select bit */
#define	TCKCUT_TRAMR	tckcut_tramr	/* Timer RA count source cutoff bit */

/* Timer RA prescaler register */
#define	TRAPRE	trapre

/* Timer RA register */
#define	TRA	tra

/* Timer RB control register */
#define	TRBCR	trbcr

#define	TSTART_TRBCR	tstart_trbcr	/* Timer RB count start bit */
#define	TCSTF_TRBCR	tcstf_trbcr	/* Timer RB count status flag */
#define	TSTOP_TRBCR	tstop_trbcr	/* Timer RB count forcible stop bit */

/* Timer RB one shot control register */
#define	TRBOCR	trbocr

#define	TOSST_TRBOCR	tosst_trbocr	/* Timer RB one-shot start bit */
#define	TOSSP_TRBOCR	tossp_trbocr	/* Timer RB one-shot stop bit */
#define	TOSSTF_TRBOCR	tosstf_trbocr	/* Timer RB one-shot status flag */

/* Timer RB I/O control register */
#define	TRBIOC	trbioc

#define	TOPL_TRBIOC	topl_trbioc	/* Timer RB output level select bit */
#define	TOCNT_TRBIOC	tocnt_trbioc	/* Timer RB output switch bit */
#define	INOSTG_TRBIOC	inostg_trbioc	/* One-shot trigger control bit */
#define	INOSEG_TRBIOC	inoseg_trbioc	/* One-shot trigger polarity select bit */

/* Timer RB mode register */
#define	TRBMR	trbmr

#define	TMOD0_TRBMR	tmod0_trbmr	/* Timer RB operating mode select bit */
#define	TMOD1_TRBMR	tmod1_trbmr	/* Timer RB operating mode select bit */
#define	TWRC_TRBMR	twrc_trbmr	/* Timer RB write control bit */
#define	TCK0_TRBMR	tck0_trbmr	/* Timer RB count source select bit */
#define	TCK1_TRBMR	tck1_trbmr	/* Timer RB count source select bit */
#define	TCKCUT_TRBMR	tckcut_trbmr	/* Timer RB count source cutoff bit */

/* Timer RB prescaler register */
#define	TRBPRE	trbpre

/* Timer RB secondary register */
#define	TRBSC	trbsc

/* Timer RB Primary Register */
#define	TRBPR	trbpr

/* Timer RE seconds data register / Timer RE counter data register */
#define	TRESEC	tresec

#define	SC00_TRESEC	sc00_tresec	/* 1st digit of seconds count bits */
#define	SC01_TRESEC	sc01_tresec	/* 1st digit of seconds count bits */
#define	SC02_TRESEC	sc02_tresec	/* 1st digit of seconds count bits */
#define	SC03_TRESEC	sc03_tresec	/* 1st digit of seconds count bits */
#define	SC10_TRESEC	sc10_tresec	/* 2nd digit of seconds count bits */
#define	SC11_TRESEC	sc11_tresec	/* 2nd digit of seconds count bits */
#define	SC12_TRESEC	sc12_tresec	/* 2nd digit of seconds count bits */
#define	BSY_TRESEC	bsy_tresec	/* Timer RE busy flag */

/* Timer RE minutes data register / Timer RE compare data register */
#define	TREMIN	tremin

#define	MN00_TREMIN	mn00_tremin	/* 1st digit of minutes count bits */
#define	MN01_TREMIN	mn01_tremin	/* 1st digit of minutes count bits */
#define	MN02_TREMIN	mn02_tremin	/* 1st digit of minutes count bits */
#define	MN03_TREMIN	mn03_tremin	/* 1st digit of minutes count bits */
#define	MN10_TREMIN	mn10_tremin	/* 2nd digit of minutes count bits */
#define	MN11_TREMIN	mn11_tremin	/* 2nd digit of minutes count bits */
#define	MN12_TREMIN	mn12_tremin	/* 2nd digit of minutes count bits */
#define	BSY_TREMIN	bsy_tremin	/* Timer RE busy flag */

/* Timer RE Hours Data Register */
#define	TREHR	trehr

#define	HR00_TREHR	hr00_trehr	/* 1st digit of hours count bits */
#define	HR01_TREHR	hr01_trehr	/* 1st digit of hours count bits */
#define	HR02_TREHR	hr02_trehr	/* 1st digit of hours count bits */
#define	HR03_TREHR	hr03_trehr	/* 1st digit of hours count bits */
#define	HR10_TREHR	hr10_trehr	/* 2nd digit of hours count bits */
#define	HR11_TREHR	hr11_trehr	/* 2nd digit of hours count bits */
#define	BSY_TREHR	bsy_trehr	/* Timer RE busy flag */

/* Timer RE Days of Week Data Register */
#define	TREWK	trewk

#define	WK0_TREWK	wk0_trewk	/* Days of week count bits */
#define	WK1_TREWK	wk1_trewk	/* Days of week count bits */
#define	WK2_TREWK	wk2_trewk	/* Days of week count bits */
#define	BSY_TREWK	bsy_trewk	/* Timer RE busy flag */

/* Timer RE control register1 */
#define	TRECR1	trecr1

#define	TCSTF_TRECR1	tcstf_trecr1	/* Timer RE count status flag */
#define	INT_TRECR1	int_trecr1	/* Interrupt request timing bit */
#define	TRERSTTRECR1	trerst_trecr1	/* Timer RE reset bit */
#define	PM_TRECR1	pm_trecr1	/* A.M. / P.M. bit */
#define	H12_H24_TRECR1	h12_h24_trecr1	/* Operating mode select bit */
#define	TSTART_TRECR1	tstart_trecr1	/* Timer RE count start bit */

/* Timer RE control register2 */
#define	TRECR2	trecr2

#define	SEIE_TRECR2	seie_trecr2	/* Periodic interrupt triggered every second enable bit */
#define	MNIE_TRECR2	mnie_trecr2	/* Periodic interrupt triggered every minute enable bit */
#define	HRIE_TRECR2	hrie_trecr2	/* Periodic interrupt triggered every hour enable bit */
#define	DYIE_TRECR2	dyie_trecr2	/* Periodic interrupt triggered every day enable bit */
#define	WKIE_TRECR2	wkie_trecr2	/* Periodic interrupt triggered every week enable bit */
#define	COMIE_TRECR2	comie_trecr2	/* Compare match interrupt enable bit */

/* Timer RE count source select register */
#define	TRECSR	trecsr

#define	RCS0_TRECSR	rcs0_trecsr	/* Count source selection bit */
#define	RCS1_TRECSR	rcs1_trecsr	/* Count source select bit */
#define	RCS2_TRECSR	rcs2_trecsr	/* 4-Bit counter select bit */
#define	RCS3_TRECSR	rcs3_trecsr	/* Real-Time clock mode select bit */

/* Timer RC mode register */
#define	TRCMR	trcmr

#define	PWMB_TRCMR	pwmb_trcmr	/* TRCIOB PWM mode select bit */
#define	PWMC_TRCMR	pwmc_trcmr	/* TRCIOC PWM mode select bit */
#define	PWMD_TRCMR	pwmd_trcmr	/* TRCIOD PWM mode select bit */
#define	PWM2_TRCMR	pwm2_trcmr	/* PWM2 mode select bit */
#define	BFC_TRCMR	bfc_trcmr	/* TRCGRC register function selection bit */
#define	BFD_TRCMR	bfd_trcmr	/* TRCGRD register function selection bit */
#define	TSTART_TRCMR	tstart_trcmr	/* TRC count start bit */

/* Timer RC control register 1 */
#define	TRCCR1	trccr1

#define	TOA_TRCCR1	toa_trccr1	/* TRCIOA output level select bit */
#define	TOB_TRCCR1	tob_trccr1	/* TRCIOB output level select bit */
#define	TOC_TRCCR1	toc_trccr1	/* TRCIOC output level select bit */
#define	TOD_TRCCR1	tod_trccr1	/* TRCIOD output level select bit */
#define	TCK0_TRCCR1	tck0_trccr1	/* Count source selection bit */
#define	TCK1_TRCCR1	tck1_trccr1	/* Count source selection bit */
#define	TCK2_TRCCR1	tck2_trccr1	/* Count source selection bit */
#define	CCLR_TRCCR1	cclr_trccr1	/* TRC counter clear select bit */

/* Timer RC interrupt enable register */
#define	TRCIER	trcier

#define	IMIEA_TRCIER	imiea_trcier	/* Input capture / compare match interrupt enable bit A */
#define	IMIEB_TRCIER	imieb_trcier	/* Input capture / compare match interrupt enable bit B */
#define	IMIEC_TRCIER	imiec_trcier	/* Input capture / compare match interrupt enable bit C */
#define	IMIED_TRCIER	imied_trcier	/* Input capture / compare match interrupt enable bit D */
#define	OVIE_TRCIER	ovie_trcier	/* Overflow / underflow interrupt enable bit */

/* Timer RC status register */
#define	TRCSR	trcsr

#define	IMFA_TRCSR	imfa_trcsr	/* Input capture / compare match flag A */
#define	IMFB_TRCSR	imfb_trcsr	/* Input capture / compare match flag B */
#define	IMFC_TRCSR	imfc_trcsr	/* Input capture / compare match flag C */
#define	IMFD_TRCSR	imfd_trcsr	/* Input capture / compare match flag D */
#define	OVF_TRCSR	ovf_trcsr	/* Overflow flag */

/* Timer RC I/O contorol register 0 */
#define	TRCIOR0	trcior0

#define	IOA0_TRCIOR0	ioa0_trcior0	/* TRCGRA control bit */
#define	IOA1_TRCIOR0	ioa1_trcior0	/* TRCGRA control bit */
#define	IOA2_TRCIOR0	ioa2_trcior0	/* TRCGRA mode selection bit */
#define	IOB0_TRCIOR0	iob0_trcior0	/* TRCGRB control bit */
#define	IOB1_TRCIOR0	iob1_trcior0	/* TRCGRB control bit */
#define	IOB2_TRCIOR0	iob2_trcior0	/* TRCGRB mode selection bit */

/* Timer RC I/O contorol register 1 */
#define	TRCIOR1	trcior1

#define	IOC0_TRCIOR1	ioc0_trcior1	/* TRCGRC control bit */
#define	IOC1_TRCIOR1	ioc1_trcior1	/* TRCGRC control bit */
#define	IOC2_TRCIOR1	ioc2_trcior1	/* TRCGRC mode selection bit */
#define	IOD0_TRCIOR1	iod0_trcior1	/* TRCGRD control bit */
#define	IOD1_TRCIOR1	iod1_trcior1	/* TRCGRD control bit */
#define	IOD2_TRCIOR1	iod2_trcior1	/* TRCGRD mode selection bit */

/* Timer RC Counter , Timer RC general register A,B,C,D */
#define	TRC	trc	/* Timer RC counter */
#define	TRCGRA	trcgra	/* Timer RC general register A */
#define	TRCGRB	trcgrb	/* Timer RC general register B */
#define	TRCGRC	trcgrc	/* Timer RC general register C */
#define	TRCGRD	trcgrd	/* Timer RC general register D */

/* Timer RC control register 2 */
#define	TRCCR2	trccr2

#define	CSEL_TRCCR2	csel_trccr2	/* Timer RC operating mode select bit */
#define	TCEG0_TRCCR2	tceg0_trccr2	/* TRCTRG input edge selection bit */
#define	TCEG1_TRCCR2	tceg1_trccr2	/* TRCTRG input edge selection bit */

/* Timer RC digital filter function selection register */
#define	TRCDF	trcdf

#define	DFA_TRCDF	dfa_trcdf	/* TRCIOA pin digital filter function selection bit */
#define	DFB_TRCDF	dfb_trcdf	/* TRCIOB pin digital filter function selection bit */
#define	DFC_TRCDF	dfc_trcdf	/* TRCIOC pin digital filter function selection bit */
#define	DFD_TRCDF	dfd_trcdf	/* TRCIOD pin digital filter function selection bit */
#define	DFTRG_TRCDF	dftrg_trcdf	/* TRCIOG pin digital filter function selection bit */
#define	DFCK0_TRCDF	dfck0_trcdf	/* Clock selection bit for digital filter function */
#define	DFCK1_TRCDF	dfck1_trcdf	/* Clock selection bit for digital filter function */

/* Timer RC output master enable register */
#define	TRCOER	trcoer

#define	EA_TRCOER	ea_trcoer	/* TRCIOA output disable bit */
#define	EB_TRCOER	eb_trcoer	/* TRCIOB output disable bit */
#define	EC_TRCOER	ec_trcoer	/* TRCIOC output disable bit */
#define	ED_TRCOER	ed_trcoer	/* TRCIOD output disable bit */
#define	PTO_TRCOER	pto_trcoer	/* INT0 of pulse output forced cutoff signal input enabled bit */

/* LIN control register */
#define	LINCR	lincr

#define	SFIE_LINCR	sfie_lincr	/* Synchronous field measurementcompleted interrupt enable bit */
#define	SBIE_LINCR	sbie_lincr	/* Synchronous break detection interrupt enable bit */
#define	BCIE_LINCR	bcie_lincr	/* Bus collision detection interrupt enable bit */
#define	RXDSF_LINCR	rxdsf_lincr	/* RxD0 input status flag */
#define	LSTART_LINCR	lstart_lincr	/* Synchronous Break detection start bit */
#define	SBE_LINCR	sbe_lincr	/* RxD0 input unmasking timing select bit */
#define	MST_LINCR	mst_lincr	/* LIN operation mode setting bit */
#define	LINE_LINCR	line_lincr	/* LIN operation start bit */

/* LIN status register */
#define	LINST	linst

#define	SFDCT_LINST	sfdct_linst	/* Synchronous field measurementcompleted flag */
#define	SBDCT_LINST	sbdct_linst	/* Synchronous break detection flag */
#define	BCDCT_LINST	bcdct_linst	/* Bus collision detection flag */
#define	B0CLR_LINST	b0clr_linst	/* SFDCT flag clear bit */
#define	B1CLR_LINST	b1clr_linst	/* SBDCT flag clear bit */
#define	B2CLR_LINST	b2clr_linst	/* BCDCT flag clear bit */

/* Flash mamory control register4 */
#define	FMR4	fmr4

#define	FMR40	fmr40	/* Erase-suspend function enable bit */
#define	FMR41	fmr41	/* Erase-suspend request bit */
#define	FMR42	fmr42	/* Program-suspend request bit */
#define	FMR43	fmr43	/* Erase command flag */
#define	FMR44	fmr44	/* Program command flag */
#define	FMR46	fmr46	/* Read status flag */
#define	FMR47	fmr47	/* Low-Power consumption read mode enable bit */

/* Flash mamory control register1 */
#define	FMR1	fmr1
#define	FMR11	fmr11	/* EW1 mode select bit */
#define	FMR15	fmr15	/* Block0 rewrite disable bit */
#define	FMR16	fmr16	/* Block1 rewrite disable bit */

/* Flash mamory control register0 */
#define	FMR0	fmr0

#define	FMR00	fmr00	/* RY/BY status flag */
#define	FMR01	fmr01	/* CPU rewrite mode select bit */
#define	FMR02	fmr02	/* Block 0, 1 rew rite enable bit */
#define	FMSTP	fmstp	/* Flash memory stop bit */
#define	FMR06	fmr06	/* Program status flag  */
#define	FMR07	fmr07	/* Erase status flag */

/*------------------------------------------------------
  Timer RE  interrupt control register
------------------------------------------------------*/
#define	TREIC	treic

#define	ILVL0_TREIC	ilvl0_treic
#define	ILVL1_TREIC	ilvl1_treic
#define	ILVL2_TREIC	ilvl2_treic
#define	IR_TREIC	ir_treic

/* Key input interrupt control register */
#define	KUPIC	kupic

#define	ILVL0_KUPIC	ilvl0_kupic
#define	ILVL1_KUPIC	ilvl1_kupic
#define	ILVL2_KUPIC	ilvl2_kupic
#define	IR_KUPIC	ir_kupic

/* A-D interrupt control register */
#define	ADIC	adic

#define	ILVL0_ADIC	ilvl0_adic
#define	ILVL1_ADIC	ilvl1_adic
#define	iLVL2_ADIC	ilvl2_adic
#define	IR_ADIC	ir_adic

/* SSU interrupt control register */
#define	SSUIC	ssuic

#define	ILVL0_SSUIC	ilvl0_ssuic
#define	ILVL1_SSUIC	ilvl1_ssuic
#define	ILVL2_SSUIC	ilvl2_ssuic
#define	IR_SSUIC	ir_ssuic

/* IIC interrupt control register */
#define	IICIC	iicic

#define	ILVL0_IICIC	ilvl0_iicic
#define	ILVL1_IICIC	ilvl1_iicic
#define	ILVL2_IICIC	ilvl2_iicic
#define	IR_IICIC	ir_iicic

/* UART0 transmit interrupt control register */
#define	S0TIC	s0tic

#define	ILVL0_S0TIC	ilvl0_s0tic
#define	ILVL1_S0TIC	ilvl1_s0tic
#define	ILVL2_S0TIC	ilvl2_s0tic
#define	IR_S0TIC	ir_s0tic

/* UART0 receive interrupt control register */
#define	S0RIC	s0ric

#define	ILVL0_S0RIC	ilvl0_s0ric
#define	ILVL1_S0RIC	ilvl1_s0ric
#define	ILVL2_S0RIC	ilvl2_s0ric
#define	IR_S0RIC	ir_s0ric

/* UART1 transmit interrupt control register */
#define	S1TIC	s1tic

#define	ILVL0_S1TIC	ilvl0_s1tic
#define	ILVL1_S1TIC	ilvl1_s1tic
#define	ILVL2_S1TIC	ilvl2_s1tic
#define	IR_S1TIC	ir_s1tic

/* UART1 receive interrupt control register */
#define	S1RIC	s1ric

#define	ILVL0_S1RIC	ilvl0_s1ric
#define	ILVL1_S1RIC	ilvl1_s1ric
#define	ILVL2_S1RIC	ilvl2_s1ric
#define	IR_S1RIC	ir_s1ric

/* Timer RA interrupt control register */
#define	TRAIC	traic

#define	ILVL0_TRAIC	ilvl0_traic
#define	ILVL1_TRAIC	ilvl1_traic
#define	ILVL2_TRAIC	ilvl2_traic
#define	IR_TRAIC	ir_traic

/* Timer RB interrupt control register */
#define	TRBIC	trbic

#define	ILVL0_TRBIC	ilvl0_trbic
#define	ILVL1_TRBIC	ilvl1_trbic
#define	ILVL2_TRBIC	ilvl2_trbic
#define	IR_TRBIC	ir_trbic

/* Timer RC interrupt control register */
#define	TRCIC	trcic

#define	ILVL0_TRCIC	ilvl0_trcic
#define	ILVL1_TRCIC	ilvl1_trcic
#define	ILVL2_TRCIC	ilvl2_trcic
#define	IR_TRCIC	ir_trcic

/* INT1 interrupt control register */
#define	INT1IC	int1ic

#define	ILVL0_INT1IC	ilvl0_int1ic
#define	ILVL1_INT1IC	ilvl1_int1ic
#define	ILVL2_INT1IC	ilvl2_int1ic
#define	IR_INT1IC	ir_int1ic
#define	POL_INT1IC	pol_int1ic

/* INT3 interrupt control register */
#define	INT3IC	int3ic

#define	ILVL0_INT3IC	ilvl0_int3ic
#define	ILVL1_INT3IC	ilvl1_int3ic
#define	ILVL2_INT3IC	ilvl2_int3ic
#define	IR_INT3IC	ir_int3ic
#define	POL_INT3IC	pol_int3ic

/* INT0 interrupt control register */
#define	INT0IC	int0ic

#define	ILVL0_INT0IC	ilvl0_int0ic
#define	ILVL1_INT0IC	ilvl1_int0ic
#define	ILVL2_INT0IC	ilvl2_int0ic
#define	IR_INT0IC	ir_int0ic
#define	POL_INT0IC	pol_int0ic

/* UARTi transmit/receive mode register */
#define	U0MR	u0mr

#define	SMD0_U0MR	smd0_u0mr	/* Serial I/O mode select bit */
#define	SMD1_U0MR	smd1_u0mr	/* Serial I/O mode select bit */
#define	SMD2_U0MR	smd2_u0mr	/* Serial I/O mode select bit */
#define	CKDIR_U0MR	ckdir_u0mr	/* Internal/external clock select bit */
#define	STPS_U0MR	stps_u0mr	/* Stop bit length select bit */
#define	PRY_U0MR	pry_u0mr	/* Odd/even parity select bit */
#define	PRYE_U0MR	prye_u0mr	/* Parity enable bit */

#define	U1MR	u1mr

#define	SMD0_U1MR	smd0_u1mr	/* Serial I/O mode select bit */
#define	SMD1_U1MR	smd1_u1mr	/* Serial I/O mode select bit */
#define	SMD2_U1MR	smd2_u1mr	/* Serial I/O mode select bit */
#define	CKDIR_U1MR	ckdir_u1mr	/* Internal/external clock select bit */
#define	STPS_U1MR	stps_u1mr	/* Stop bit length select bit */
#define	PRY_U1MR	pry_u1mr	/* Odd/even parity select bit */
#define	PRYE_U1MR	prye_u1mr	/* Parity enable bit */

/* UARTi transmit/receive control register0 */
#define	U0C0	u0c0

#define	CLK0_U0C0	clk0_u0c0	/* BRG count source select bit */
#define	CLK1_U0C0	clk1_u0c0	/* BRG count source select bit */
#define	TXEPT_U0C0	txept_u0c0	/* Transmit register empty flag */
#define	NCH_U0C0	nch_u0c0	/* Data output select bit */
#define	CKPOL_U0C0	ckpol_u0c0	/* CLK polarity select bit */
#define	UFORM_U0C0	uform_u0c0	/* Transfer format select bit */

#define	U1C0	u1c0

#define	CLK0_U1C0	clk0_u1c0	/* BRG count source select bit */
#define	CLK1_U1C0	clk1_u1c0	/* BRG count source select bit */
#define	TXEPT_U1C0	txept_u1c0	/* Transmit register empty flag */
#define	NCH_U1C0	nch_u1c0	/* Data output select bit */
#define	CKPOL_U1C0	ckpol_u1c0	/* CLK polarity select bit */
#define	UFORM_U1C0	uform_u1c0	/* Transfer format select bit */

/* UARTi transmit/receive control register1 */
#define	U0C1	u0c1

#define	TE_U0C1	te_u0c1		/* Transmit enable bit */
#define	TI_U0C1	ti_u0c1		/* Transmit buffer empty flag */
#define	RE_U0C1	re_u0c1		/* Receive enable bit */
#define	RI_U0C1	ri_u0c1		/* Receive complete flag */
#define	U0IRS_U0C1	u0irs_u0c1	/* UART0 transmit interrupt cause select bit */
#define	U0RRM_U0C1	u0rrm_u0c1	/* UART0 continuous receive mode enable bit */

#define	U1C1	u1c1

#define	TE_U1C1	te_u1c1		/* Transmit enable bit */
#define	TI_U1C1	ti_u1c1		/* Transmit buffer empty flag */
#define	RE_U1C1	re_u1c1		/* Receive enable bit */
#define	RI_U1C1	ri_u1c1		/* Receive complete flag */
#define	U1IRS_U1C1	u1irs_u1c1	/* UART1 transmit interrupt cause select bit */
#define	U1RRM_U1C1	u1rrm_u1c1	/* UART1 continuous receive mode enable bit */

/* UARTi receive buffer register */
#define	U0RB	u0rb
#define	U0RBL	u0rbl
#define	U0RBH	u0rbh

#define	OER_U0RB	oer_u0rb	/* Overrun error flag */
#define	FER_U0RB	fer_u0rb	/* Framing error flag */
#define	PER_U0RB	per_u0rb	/* Parity error flag */
#define	SUM_U0RB	sum_u0rb	/* Error sum flag */

#define	U1RB	u1rb
#define	U1RBL	u1rbl
#define	U1RBH	u1rbh

#define	OER_U1RB	oer_u1rb	/* Overrun error flag */
#define	FER_U1RB	fer_u1rb	/* Framing error flag */
#define	PER_U1RB	per_u1rb	/* Parity error flag */
#define	SUM_U1RB	sum_u1rb	/* Error sum flag */

#define	RMAD0	rmad0		/* Address match interrupt register0 */
#define	RMAD0L	rmad0l		/* Address match interrupt register0 Low */
#define	RMAD0M	rmad0m		/* Address match interrupt register0 Middle */
#define	RMAD0H	rmad0h		/* Address match interrupt register0 High */
#define	RMAD1	rmad1		/* Address match interrupt register1 */
#define	RMAD1L	rmad1l		/* Address match interrupt register1 Low */
#define	RMAD1M	rmad1m		/* Address match interrupt register1 Middle */
#define	Rmad1H	rmad1h		/* Address match interrupt register1 High */

#define	U0TB	u0tb		/* UART0 transmit buffer register */
#define	U0TBL	u0tbl		/* UART0 transmit buffer register Low */
#define	U0TBH	u0tbh		/* UART0 transmit buffer register High */
#define	U1TB	u1tb		/* UART1 transmit buffer register */
#define	U1TBL	u1tbl		/* UART1 transmit buffer register Low */
#define	U1TBH	u1tbh		/* UART1 transmit buffer register High */
#define	AD	ad		/* A-D register  */
#define	ADL	adl		/* A-D register Low */
#define	ADH	adh		/* A-D register High */

/* end of r8c29.h */
